<script lang="ts" setup>
import type { Booking, Promo, Room } from '@/entities';
import { doAndNotify } from '@/form-helpers';
import { useBookingStore } from '@/stores/booking';
import { usePromoStore } from '@/stores/promo';
import { storeToRefs } from 'pinia';
import { onMounted, ref } from 'vue';
import {datesAreOnSameDay} from '../form-helpers';

const { withButton, booking} = defineProps<{
    withButton: boolean,
    booking: Booking
}>();

const emit = defineEmits({
    modalClosed(){return true}
})

const bookingStore = useBookingStore();
const promoStore = usePromoStore();
const {promos} = storeToRefs(promoStore);

const centerDialogVisible = ref(!withButton);

const valueDate = ref<any>([booking.startDate ? booking.startDate:new Date(), booking.endDate ? booking.endDate: new Date()]);
const valuePromo = ref<Promo|undefined>(booking.promo);
const periode = ref('full');

const onSubmit = () => {
    valueDate.value[0].setHours(9);
    valueDate.value[1].setHours(18);
    if(periode.value == 'am') {
        valueDate.value[1].setHours(13);
    }
    if(periode.value == 'pm') {
        valueDate.value[0].setHours(14)
    }
    if(booking?.id) {
        doAndNotify({
            id: booking.id,
            startDate:valueDate.value[0],
            endDate: valueDate.value[1],
            promo: valuePromo.value,
            room: booking.room
        }, bookingStore.updateBooking, 'mise à jour');
    } else {
        doAndNotify({
            startDate:valueDate.value[0],
            endDate: valueDate.value[1],
            promo: valuePromo.value,
            room: booking.room
        }, bookingStore.persistBookings, 'réservation');
    }
    
    centerDialogVisible.value = false;
}

const removeBooking = () => {
    doAndNotify(booking, bookingStore.removeBooking, 'suppression');
    centerDialogVisible.value = false;
}

onMounted(() => {
    promoStore.fetchPromos();
})


</script>
    
<template >
    <el-button v-if="withButton" type="success" plain @click="centerDialogVisible = true">Reserver</el-button>

    <el-dialog @closed="emit('modalClosed')" v-model="centerDialogVisible" :title="booking.room?.name" width="50%" align-center>

        <el-form v:model="form" label-width="120px">

            <el-form-item style="padding: 10px" label="Choisir la promo">
                <el-select v-model="valuePromo" placeholder="Selectionnez la promo" value-key="id">
                    <el-option v-for="promo in promos" :label="promo.name" :value="promo" />
                </el-select>
            </el-form-item>

            <el-form-item style="padding: 10px" label="Date">
                <div class="block">
                    <el-date-picker v-model="valueDate" format="DD/MM/YYYY" type="daterange" range-separator="au"
                        start-placeholder="Start date" end-placeholder="End date" />
                </div>
            </el-form-item>
            <el-form-item v-if="datesAreOnSameDay(valueDate[0], valueDate[1])" label="Période">
                <el-select v-model="periode" class="m-2">
                    <el-option label="Journée entière" key="full" value="full"></el-option>
                    <el-option label="Matin" key="am" value="am"></el-option>
                    <el-option label="Après midi" key="pm" value="pm"></el-option>
                </el-select>

            </el-form-item>
            
            <el-form-item>
                <el-button v-if="!booking.id" type="primary" @click="onSubmit">Assigner</el-button>
                <div v-if="booking.id">
                    <el-button type="primary" @click="onSubmit">Mettre à jour</el-button>
                    
                    <el-popconfirm title="Supprimer la réservation ?" confirm-button-text="Oui" cancel-button-text="Non"
                    @confirm="removeBooking">
                    <template #reference>
                        <el-button type="info">
                            Supprimer
                        </el-button>
                    </template>
                </el-popconfirm>
                    
                </div>
            </el-form-item>
        </el-form>

    </el-dialog>
</template>
<style scoped>
.dialog-footer button:first-child {
    margin-right: 10px;
}
</style>
    